; ; ; ; MIT License
; ; ; ; 
; ; ; ; Copyright (c) 2020 Carlos Eduardo Arismendi Sánchez / Antón Chernysh / Sergio Cortés Espinosa
; ; ; ; 
; ; ; ; Permission is hereby granted, free of charge, to any person obtaining a copy
; ; ; ; of this software and associated documentation files (the "Software"), to deal
; ; ; ; in the Software without restriction, including without limitation the rights
; ; ; ; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
; ; ; ; copies of the Software, and to permit persons to whom the Software is
; ; ; ; furnished to do so, subject to the following conditions:
; ; ; ; 
; ; ; ; The above copyright notice and this permission notice shall be included in all
; ; ; ; copies or substantial portions of the Software.
; ; ; ;
; ; ; ; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
; ; ; ; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
; ; ; ; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
; ; ; ; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
; ; ; ; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
; ; ; ; OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
; ; ; ; SOFTWARE.

; ; ; ; ----------------- AUTHORS ------------------
; ; ; ; Code & Graphics: 
; ; ; ;     Anton Chernysh: anton_chernysh@outlook.es 
; ; ; ;     Carlos Eduardo Arismendi Sánchez: carlos.arismendisanchez@gmail.com
; ; ; ; Loading screen & Music: 
; ; ; ;     Sergio Cortes Espinosa: sercotes93@gmail.com
; ; ; ; ---------------------------------------------

; ; ; ; Third Party source code used
; ; ; ; ----------------------------
; ; ; ; CPCtelera - owned by ronaldo / (Cheesetea, Fremos, ByteRealms) - GNU Lesser General Public License.

;;
;;  MAP MANAGER HEADER
;;

.globl  man_map_init
.globl  man_map_update
.globl  man_map_terminate

;.globl  man_map_create_map

.globl  man_map_get_lvl_map
.globl  man_map_get_map_array

;.globl  man_map_set_block_type

;;########################################################
;;                        MACROS                         #              
;;########################################################

;;-----------------------  BLOCK  ------------------------
.macro DefineEnemy _cx, _cy, _vx, _vy
    .db (_cx*4)+2,     (_cy*16)+12       ;; screen coordinates
    .db _cx,    _cy             ;; map coordinates
    .db _vx,    _vy             ;; velocity
.endm


.macro DefineBlock _type
    .db _type
.endm

.macro DefineBlockDefault    
    .db default_btype        
.endm

.macro DefineBlockArray _Tname,_N,_DefineBlock
    _Tname'_array: 
    .rept _N    
        _DefineBlock
    .endm
.endm


.macro DefineLevel1Map    
    .db 0xFF,   0xDD,   0xFF,   0xFF,   0xFF,   0xDD,   0xFF,   0xFF,   0xFF,   0xDD,   0xFF,   0xFF,   0xFF,   0xDD,   0xFF,   0xFF,   0xFF,   0xDD,   0xEE
    .db 0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF
    .db 0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF
    .db 0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF
    .db 0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF
    .db 0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF
    .db 0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF
    .db 0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF
    .db 0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF
    .db 0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF
    .db 0xFF,   0xFF,   0xFF,   0xDD,   0xFF,   0xFF,   0xFF,   0xDD,   0xFF,   0xFF,   0xFF,   0xDD,   0xFF,   0xFF,   0xFF,   0xDD,   0xFF,   0xFF,   0xFF
.endm


.macro DefineLevel2Map     
    .db 0xFF,   0xDD,   0xFF,   0xFF,   0xFF,   0xDD,   0xFF,   0xFF,   0xFF,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD
    .db 0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xDD
    .db 0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xFF,   0xDD
    .db 0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xFF,   0xFF,   0xFF,   0xDD,   0xFF,   0xDD
    .db 0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD
    .db 0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xDD,   0xFF,   0xEE,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD
    .db 0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD
    .db 0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xDD
    .db 0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xFF,   0xDD
    .db 0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xDD
    .db 0xFF,   0xFF,   0xFF,   0xDD,   0xFF,   0xFF,   0xFF,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD
.endm

.macro DefineLevel3Map    
    .db 0xFF,   0xDD,   0xFF,   0xFF,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xEE,   0xDD      
    .db 0xFF,   0xDD,   0xFF,   0xFF,   0xDD,   0xFF,   0xFF,   0xFF,   0xDD,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xDD,   0xFF,   0xDD   
    .db 0xFF,   0xDD,   0xFF,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xDD,   0xFF,   0xDD   
    .db 0xFF,   0xDD,   0xFF,   0xFF,   0xDD,   0xFF,   0xDD,   0xDD,   0xDD,   0xFF,   0xDD,   0xDD,   0xFF,   0xDD,   0xFF,   0xFF,   0xDD,   0xFF,   0xDD   
    .db 0xFF,   0xDD,   0xDD,   0xFF,   0xFF,   0xFF,   0xDD,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xDD,   0xFF,   0xDD   
    .db 0xFF,   0xDD,   0xFF,   0xFF,   0xDD,   0xDD,   0xDD,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xDD,   0xFF,   0xDD   
    .db 0xFF,   0xDD,   0xFF,   0xFF,   0xDD,   0xFF,   0xFF,   0xFF,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xFF,   0xDD   
    .db 0xFF,   0xDD,   0xFF,   0xFF,   0xDD,   0xFF,   0xDD,   0xDD,   0xDD,   0xFF,   0xFF,   0xDD,   0xDD,   0xFF,   0xFF,   0xDD,   0xDD,   0xFF,   0xDD   
    .db 0xFF,   0xDD,   0xFF,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xDD   
    .db 0xFF,   0xDD,   0xFF,   0xDD,   0xDD,   0xFF,   0xDD,   0xFF,   0xFF,   0xDD,   0xDD,   0xFF,   0xFF,   0xDD,   0xDD,   0xFF,   0xFF,   0xFF,   0xDD   
    .db 0xFF,   0xFF,   0xFF,   0xDD,   0xDD,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xDD   
.endm

.macro DefineLevel4Map    
    .db 0xFF,   0xFF,   0xFF,   0xFF,   0xDD,   0xDD,   0xDD,   0xFF,   0xDD,   0xDD,   0xDD,   0xFF,   0xDD,   0xDD,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF   
    .db 0xFF,   0xFF,   0xFF,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xFF,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xFF,   0xFF,   0xFF   
    .db 0xFF,   0xFF,   0xFF,   0xFF,   0xDD,   0xDD,   0xDD,   0xFF,   0xDD,   0xDD,   0xDD,   0xFF,   0xDD,   0xDD,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF   
    .db 0xFF,   0xFF,   0xFF,   0xFF,   0xDD,   0xFF,   0xFF,   0xFF,   0xDD,   0xFF,   0xFF,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xFF,   0xFF,   0xFF   
    .db 0xFF,   0xFF,   0xFF,   0xFF,   0xDD,   0xFF,   0xFF,   0xFF,   0xDD,   0xDD,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xFF,   0xFF,   0xFF   
    .db 0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF   
    .db 0xFF,   0xFF,   0xFF,   0xFF,   0xDD,   0xDD,   0xDD,   0xFF,   0xDD,   0xDD,   0xDD,   0xFF,   0xFF,   0xDD,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF   
    .db 0xFF,   0xFF,   0xFF,   0xFF,   0xDD,   0xFF,   0xFF,   0xFF,   0xFF,   0xDD,   0xFF,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xFF,   0xFF,   0xFF   
    .db 0xFF,   0xFF,   0xFF,   0xFF,   0xDD,   0xDD,   0xDD,   0xFF,   0xFF,   0xDD,   0xFF,   0xFF,   0xDD,   0xDD,   0xDD,   0xFF,   0xFF,   0xFF,   0xFF   
    .db 0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xDD,   0xFF,   0xFF,   0xDD,   0xFF,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xFF,   0xFF,   0xFF   
    .db 0xFF,   0xFF,   0xFF,   0xFF,   0xDD,   0xDD,   0xDD,   0xFF,   0xDD,   0xDD,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xFF,   0xFF,   0xEE   
.endm

.macro DefineLevel5Map   
    .db 0xFF,   0xDD,   0xDD,   0xFF,   0xFF,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD
    .db 0xFF,   0xDD,   0xDD,   0xFF,   0xFF,   0xDD,   0xFF,   0xFF,   0xFF,   0xFF,   0xDD,   0xDD,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF
    .db 0xFF,   0xDD,   0xDD,   0xFF,   0xFF,   0xDD,   0xFF,   0xDD,   0xDD,   0xFF,   0xDD,   0xDD,   0xFF,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD
    .db 0xFF,   0xDD,   0xDD,   0xFF,   0xFF,   0xFF,   0xFF,   0xDD,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xDD,   0xDD,   0xFF,   0xFF,   0xFF,   0xFF
    .db 0xFF,   0xDD,   0xDD,   0xFF,   0xFF,   0xDD,   0xDD,   0xDD,   0xFF,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xFF,   0xFF,   0xFF,   0xEE
    .db 0xFF,   0xDD,   0xDD,   0xFF,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xDD,   0xDD,   0xDD
    .db 0xFF,   0xDD,   0xDD,   0xFF,   0xFF,   0xDD,   0xFF,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xFF,   0xFF
    .db 0xFF,   0xDD,   0xDD,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xDD,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF
    .db 0xFF,   0xDD,   0xDD,   0xFF,   0xFF,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xFF,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD
    .db 0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF
    .db 0xFF,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD
.endm


.macro DefineLevel6Map    
    .db 0xFF,   0xDD,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xDD,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF   
    .db 0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xDD,   0xDD,   0xFF,   0xDD,   0xDD,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xDD,   0xDD,   0xFF   
    .db 0xFF,   0xDD,   0xFF,   0xFF,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xFF,   0xFF,   0xDD,   0xFF   
    .db 0xFF,   0xFF,   0xFF,   0xDD,   0xDD,   0xDD,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xDD,   0xFF,   0xFF,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF   
    .db 0xDD,   0xDD,   0xDD,   0xDD,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF   
    .db 0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xDD,   0xDD,   0xDD,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF   
    .db 0xFF,   0xDD,   0xDD,   0xDD,   0xFF,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xFF,   0xDD,   0xFF   
    .db 0xFF,   0xDD,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF   
    .db 0xFF,   0xDD,   0xDD,   0xDD,   0xFF,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xFF,   0xFF   
    .db 0xFF,   0xFF,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF   
    .db 0xFF,   0xFF,   0xFF,   0xFF,   0xEE,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF   
.endm

.macro DefineLevel7Map    
    .db 0xFF,   0xDD,   0xDD,   0xDD,   0xDD,   0xFF,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD
    .db 0xFF,   0xFF,   0xFF,   0xFF,   0xDD,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD
    .db 0xFF,   0xDD,   0xDD,   0xDD,   0xDD,   0xFF,   0xFF,   0xDD,   0xDD,   0xDD,   0xFF,   0xFF,   0xDD,   0xDD,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF
    .db 0xFF,   0xDD,   0xDD,   0xDD,   0xFF,   0xFF,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xFF,   0xDD,   0xDD,   0xFF,   0xDD,   0xFF,   0xFF,   0xFF
    .db 0xFF,   0xDD,   0xDD,   0xDD,   0xDD,   0xFF,   0xFF,   0xDD,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xDD,   0xFF,   0xFF,   0xFF
    .db 0xFF,   0xDD,   0xDD,   0xDD,   0xDD,   0xFF,   0xFF,   0xDD,   0xDD,   0xDD,   0xDD,   0xFF,   0xDD,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xDD
    .db 0xFF,   0xDD,   0xDD,   0xDD,   0xFF,   0xFF,   0xDD,   0xDD,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xDD,   0xFF,   0xFF,   0xFF
    .db 0xFF,   0xDD,   0xDD,   0xDD,   0xDD,   0xFF,   0xFF,   0xDD,   0xDD,   0xDD,   0xDD,   0xFF,   0xDD,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xDD
    .db 0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xDD,   0xDD,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xDD,   0xFF,   0xFF,   0xFF
    .db 0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xFF,   0xDD,   0xDD,   0xFF,   0xDD,   0xFF,   0xFF,   0xEE
    .db 0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xFF,   0xFF,   0xFF,   0xFF,   0xDD,   0xDD,   0xDD,   0xDD
.endm

.macro DefineLevel8Map    
    .db 0xFF,   0xFF,   0xDD,   0xFF,   0xFF,   0xFF,   0xDD,   0xEE,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF   
    .db 0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xFF,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xFF   
    .db 0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xDD,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF   
    .db 0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xDD,   0xDD,   0xDD,   0xFF,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD   
    .db 0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF   
    .db 0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xFF,   0xFF,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xFF   
    .db 0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF   
    .db 0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD   
    .db 0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xDD,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF   
    .db 0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xFF,   0xDD,   0xDD,   0xDD,   0xFF,   0xDD,   0xDD,   0xFF   
    .db 0xDD,   0xFF,   0xFF,   0xFF,   0xDD,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF   
.endm

.macro DefineLevel9Map    
    .db 0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF   
    .db 0xFF,   0xFF,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF   
    .db 0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xDD,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF   
    .db 0xFF,   0xFF,   0xFF,   0xFF,   0xDD,   0xDD,   0xFF,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xFF,   0xDD,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF   
    .db 0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xDD,   0xFF,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xFF,   0xDD,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF   
    .db 0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xDD,   0xFF,   0xFF,   0xFF,   0xEE,   0xDD,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF   
    .db 0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xDD,   0xFF,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xFF,   0xDD,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF   
    .db 0xFF,   0xFF,   0xFF,   0xFF,   0xDD,   0xDD,   0xFF,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xFF,   0xDD,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF   
    .db 0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xDD,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF   
    .db 0xFF,   0xFF,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF   
    .db 0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF   
.endm

.macro DefineLevel10Map    
    .db 0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF   
    .db 0xFF,   0xFF,   0xFF,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD   
    .db 0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xDD,   0xFF,   0xFF,   0xDD,   0xDD,   0xDD,   0xFF,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD   
    .db 0xDD,   0xDD,   0xFF,   0xFF,   0xFF,   0xDD,   0xFF,   0xFF,   0xDD,   0xEE,   0xFF,   0xFF,   0xFF,   0xFF,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD   
    .db 0xDD,   0xDD,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xDD,   0xDD,   0xDD,   0xFF,   0xDD,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF   
    .db 0xDD,   0xDD,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xDD,   0xDD,   0xDD,   0xFF,   0xFF,   0xFF,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD   
    .db 0xDD,   0xDD,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xDD,   0xDD,   0xDD,   0xFF,   0xFF,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD   
    .db 0xDD,   0xDD,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xDD,   0xDD,   0xDD,   0xFF,   0xFF,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD   
    .db 0xDD,   0xDD,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xDD,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xDD   
    .db 0xDD,   0xDD,   0xFF,   0xDD,   0xFF,   0xFF,   0xFF,   0xDD,   0xFF,   0xFF,   0xFF,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD   
    .db 0xDD,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xDD,   0xFF,   0xFF,   0xFF,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD,   0xDD   
.endm

; .macro DefineLevelXMap    
;     .db 0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF   
;     .db 0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF   
;     .db 0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF   
;     .db 0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF   
;     .db 0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF   
;     .db 0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF   
;     .db 0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF   
;     .db 0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF   
;     .db 0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF   
;     .db 0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF   
;     .db 0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF,   0xFF   
; .endm



.macro DefineMapsArray _Tname    
    _Tname'_num:    .db 1    
    _Tname'_last:   .dw _Tname'_array
    _Tname'_array:   
                                      
        DefineLevel1Map
        DefineLevel2Map 
        DefineLevel3Map               
        DefineLevel4Map
        DefineLevel5Map 
        DefineLevel6Map
        DefineLevel7Map
        DefineLevel8Map
        DefineLevel9Map
        DefineLevel10Map  
.endm

;;########################################################
;;                       CONSTANTS                       #             
;;########################################################

;;---------------------  BLOCK ENTITY  -------------------

b_type = 0
sizeof_block  = 1
sizeof_map    = 19*11
max_maps = 10

;;########################################################
;;                      BLOCK TYPES                     #             
;;########################################################
default_btype = 0xFF ;floor
solid_btype = 0xDD   ;solid block, immutable
box_btype = 0xBB     ;box block, mutable
exit_btype = 0xEE     ;box block, mutable

map_array_end = 0x00